import pygame
import random
import toolbox


class PowerUp(pygame.sprite.Sprite):
    def __init__(self, screen, x, y):
        pygame.sprite.Sprite.__init__(self, self.containers)
        self.screen = screen
        self.x = x
        self.y = y
        self.pick_power = random.randint(0, 7)
        # when testing new powerups, comment out random and replace with number
        if self.pick_power == 0: # Crate ammo
            self.image = pygame.image.load("../assets/powerupCrate.png")
            self.background_image = pygame.image.load("../assets/powerupBackgroundBlue.png")
            self.power_type = 'crateammo'
        elif self.pick_power == 1: # Explosive crate ammo
            self.image = pygame.image.load("../assets/powerupExplosiveBarrel.png")
            self.background_image = pygame.image.load("../assets/powerupBackgroundBlue.png")
            self.power_type = 'explosiveammo'
        elif self.pick_power == 2: # Split shot
            self.image = pygame.image.load("../assets/powerupSplitPurple.png")
            self.background_image = pygame.image.load("../assets/powerupBackgroundRed.png")
            self.power_type = 'split'
        elif self.pick_power == 3: # Stream shot
            self.image = pygame.image.load("../assets/powerupDrop.png")
            self.background_image = pygame.image.load("../assets/powerupBackgroundRed.png")
            self.power_type = 'stream'
        elif self.pick_power == 4: # Explosive/Burst shot
            self.image = pygame.image.load("../assets/SplashSmall1.png")
            self.background_image = pygame.image.load("../assets/powerupBackgroundRed.png")
            self.power_type = 'burst'
        elif self.pick_power == 5: # +10 health pickup
            self.image = pygame.image.load("../assets/heart_bigger.png")
            self.background_image = pygame.image.load("../assets/powerupBackgroundBlue.png")
            self.power_type = 'health'
        elif self.pick_power == 6: #rocket launcher
            self.image = pygame.image.load("../assets/SmallExplosion2.png")
            self.background_image = pygame.image.load("../assets/powerupBackgroundRed.png")
            self.power_type = 'rocket'
        elif self.pick_power == 7: # Bouncy Balloon shot
            self.image = pygame.image.load("../assets/powerupBalloonSmallBouncy.png")
            self.background_image = pygame.image.load("../assets/powerupBackgroundRed.png")
            self.power_type = 'bouncy'
        #elif self.pick_power == 8: # Lava Balloon powerup And-E did Magic
            #self.image = pygame.image.load("../assets/BalloonSmallLava.png")
            #self.background_image = pygame.image.load("../assets/powerupBackgroundRed.png")
            #self.power_type = 'lava'
            # or replace image below with background_image to collect powerup when colliding with the outside
        self.rect = self.image.get_rect()
        self.rect.center = (self.x, self.y)
        self.background_angle = 0
        self.spinny_speed = 2
        self.despawn_timer = 400
        self.sfx_pickup = pygame.mixer.Sound("../assets/sfx/powerup.wav")

    def update(self, player):
#        print(self.despawn_timer % 10)
        if self.rect.colliderect(player.rect):
            self.sfx_pickup.play()
            player.powerUp(self.power_type)
            self.kill()

        self.despawn_timer -= 1
        if self.despawn_timer <= 0:
            self.kill()

        self.background_angle += self.spinny_speed
        bg_image_to_draw, bg_rect = toolbox.getRotatedImage(self.background_image, self.rect, self.background_angle)

        if self.despawn_timer > 120 or self.despawn_timer % 10 > 5:
            self.screen.blit(bg_image_to_draw, bg_rect)
            self.screen.blit(self.image, self.rect)
